# Reference

<!-- DO NOT EDIT: This document was generated by Puppet Strings -->

## Table of Contents

### Resource types

* [`dsc_xscvmmadmin`](#dsc_xscvmmadmin): The DSC xSCVMMAdmin resource type. Automatically generated from version 1.2.4.0
* [`dsc_xscvmmconsolesetup`](#dsc_xscvmmconsolesetup): The DSC xSCVMMConsoleSetup resource type. Automatically generated from version 1.2.4.0
* [`dsc_xscvmmconsoleupdate`](#dsc_xscvmmconsoleupdate): The DSC xSCVMMConsoleUpdate resource type. Automatically generated from version 1.2.4.0
* [`dsc_xscvmmmanagementserversetup`](#dsc_xscvmmmanagementserversetup): The DSC xSCVMMManagementServerSetup resource type. Automatically generated from version 1.2.4.0
* [`dsc_xscvmmmanagementserverupdate`](#dsc_xscvmmmanagementserverupdate): The DSC xSCVMMManagementServerUpdate resource type. Automatically generated from version 1.2.4.0
* [`dsc_xscvmmoperationsmanagerserver`](#dsc_xscvmmoperationsmanagerserver): The DSC xSCVMMOperationsManagerServer resource type. Automatically generated from version 1.2.4.0

## Resource types

### `dsc_xscvmmadmin`

The DSC xSCVMMAdmin resource type.
Automatically generated from version 1.2.4.0

#### Properties

The following properties are available in the `dsc_xscvmmadmin` type.

##### `dsc_ensure`

Data type: `Optional[Enum['Present', 'Absent']]`

An enumerated value that describes if the principal is an Virtual Machine Manager admin. Present {default}   Absent    

#### Parameters

The following parameters are available in the `dsc_xscvmmadmin` type.

##### `dsc_principal`

namevar

Data type: `String`

The Virtual Machine Manager admin principal.

##### `dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### `dsc_scvmmadmincredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

Credential to be used to perform the operations.

##### `dsc_userrole`

namevar

Data type: `String`

The Virtual Machine Manager user role.

##### `name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

### `dsc_xscvmmconsolesetup`

The DSC xSCVMMConsoleSetup resource type.
Automatically generated from version 1.2.4.0

#### Properties

The following properties are available in the `dsc_xscvmmconsolesetup` type.

##### `dsc_indigotcpport`

Data type: `Optional[Integer[0, 65535]]`

Port for communication with the VMM management server.

##### `dsc_muoptin`

Data type: `Optional[Hash]`

0: Do not opt in to Microsoft Update. 1: Opt in to Microsoft Update.

##### `dsc_programfiles`

Data type: `Optional[String]`

Installation path for the software.

##### `dsc_sourcefolder`

Data type: `Optional[String]`

Folder within the source path containing the source files for installation.

##### `dsc_sourcepath`

Data type: `String`

UNC path to the root of the source files for installation.

#### Parameters

The following parameters are available in the `dsc_xscvmmconsolesetup` type.

##### `dsc_ensure`

namevar

Data type: `Enum['Present', 'Absent']`

An enumerated value that describes if the DPM server is expected to be installed on the machine. Present {default}  
Absent

##### `dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### `dsc_setupcredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

Credential to be used to perform the installation.

##### `name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

### `dsc_xscvmmconsoleupdate`

The DSC xSCVMMConsoleUpdate resource type.
Automatically generated from version 1.2.4.0

#### Properties

The following properties are available in the `dsc_xscvmmconsoleupdate` type.

##### `dsc_sourcefolder`

Data type: `Optional[String]`

Folder within the source path containing the source files for installation.

##### `dsc_sourcepath`

Data type: `String`

UNC path to the root of the source files for installation.

##### `dsc_update`

Data type: `Optional[String]`

Display name of the update.

#### Parameters

The following parameters are available in the `dsc_xscvmmconsoleupdate` type.

##### `dsc_ensure`

namevar

Data type: `Enum['Present', 'Absent']`

An enumerated value that describes if the update is expected to be installed on the machine. Present {default}   Absent

##### `dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### `dsc_setupcredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

Credential to be used to perform the installation.

##### `name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

### `dsc_xscvmmmanagementserversetup`

The DSC xSCVMMManagementServerSetup resource type.
Automatically generated from version 1.2.4.0

#### Properties

The following properties are available in the `dsc_xscvmmmanagementserversetup` type.

##### `dsc_bitstcpport`

Data type: `Optional[Integer[0, 65535]]`

Port for file transfers to agents on hosts and library servers.

##### `dsc_clustermanagementserver`

Data type: `Optional[Boolean]`

Is this a clustered Management Server?

##### `dsc_companyname`

Data type: `Optional[String]`

Display name for the organization.

##### `dsc_createnewlibraryshare`

Data type: `Optional[String]`

0: Use an existing library share. 1: Create a new library share.

##### `dsc_createnewsqldatabase`

Data type: `Optional[String]`

0: Use an existing Microsoft SQL Server database. 1: Create a new SQL Server database.

##### `dsc_firstmanagementserver`

Data type: `Optional[Boolean]`

Is this the first Management Server?

##### `dsc_forcehavmmuninstall`

Data type: `Optional[Hash]`

0: Do not force uninstallation if setup.exe cannot verify whether this node is the final node of the highly available installation. 1: Force the uninstallation.

##### `dsc_indigohttpport`

Data type: `Optional[Integer[0, 65535]]`

Port for communication with Windows PE agent for time synchronization.

##### `dsc_indigohttpsport`

Data type: `Optional[Integer[0, 65535]]`

Port for communication with the Windows Preinstallation Environment agents.

##### `dsc_indigonettcpport`

Data type: `Optional[Integer[0, 65535]]`

Port for communication with Windows Deployment Services.

##### `dsc_indigotcpport`

Data type: `Optional[Integer[0, 65535]]`

Port for communication with the VMM console.

##### `dsc_librarysharedescription`

Data type: `Optional[String]`

Description of the share.

##### `dsc_librarysharename`

Data type: `Optional[String]`

Name of the file share to be used or created.

##### `dsc_librarysharepath`

Data type: `Optional[String]`

Location of the existing file share or the new file share to be created.

##### `dsc_muoptin`

Data type: `Optional[Hash]`

0: Do not opt in to Microsoft Update. 1: Opt in to Microsoft Update.

##### `dsc_productkey`

Data type: `Optional[String]`

Product key for licensed installations.

##### `dsc_programfiles`

Data type: `Optional[String]`

Installation path for the software.

##### `dsc_retainsqldatabase`

Data type: `Optional[Hash]`

0: Remove the SQL Server database. 1: Do not remove the SQL Server database.

##### `dsc_sourcefolder`

Data type: `Optional[String]`

Folder within the source path containing the source files for installation.

##### `dsc_sourcepath`

Data type: `String`

UNC path to the root of the source files for installation.

##### `dsc_sqldatabasename`

Data type: `Optional[String]`

Name of the new or existing SQL Server database.

##### `dsc_sqlinstancename`

Data type: `String`

Name of the new or existing instance of SQL Server.

##### `dsc_sqlmachinename`

Data type: `String`

Name of the server that is hosting SQL Server.

##### `dsc_sqmoptin`

Data type: `Optional[Hash]`

0: Do not opt in to the Customer Experience Improvement Program (CEIP). 1: Opt in to CEIP.

##### `dsc_topcontainername`

Data type: `Optional[String]`

Container for Distributed Key Management.

##### `dsc_username`

Data type: `Optional[String]`

Display name for the user.

##### `dsc_vmmservername`

Data type: `Optional[String]`

Clustered service name for a highly available VMM management server.

##### `dsc_vmmserviceusername`

Data type: `Optional[String]`

Output username of the VMM service.

##### `dsc_vmmstaticipaddress`

Data type: `Optional[String]`

IP address for the clustered service name for a highly available VMM management server, if you are not using Dynamic Host Configuration Protocol (DHCP).

##### `dsc_wsmantcpport`

Data type: `Optional[Integer[0, 65535]]`

Port for communication with agents on hosts and library servers.

#### Parameters

The following parameters are available in the `dsc_xscvmmmanagementserversetup` type.

##### `dsc_ensure`

namevar

Data type: `Enum['Present', 'Absent']`

An enumerated value that describes if the DPM server is expected to be installed on the machine. Present {default}  
Absent

##### `dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### `dsc_setupcredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

Credential to be used to perform the installation.

##### `dsc_vmmservice`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

Domain account for the VMM service.

##### `name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

### `dsc_xscvmmmanagementserverupdate`

The DSC xSCVMMManagementServerUpdate resource type.
Automatically generated from version 1.2.4.0

#### Properties

The following properties are available in the `dsc_xscvmmmanagementserverupdate` type.

##### `dsc_sourcefolder`

Data type: `Optional[String]`

Folder within the source path containing the source files for installation.

##### `dsc_sourcepath`

Data type: `String`

UNC path to the root of the source files for installation.

##### `dsc_update`

Data type: `Optional[String]`

Display name of the update.

#### Parameters

The following parameters are available in the `dsc_xscvmmmanagementserverupdate` type.

##### `dsc_ensure`

namevar

Data type: `Enum['Present', 'Absent']`

An enumerated value that describes if the update is expected to be installed on the machine. Present {default}   Absent

##### `dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### `dsc_setupcredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

Credential to be used to perform the installation.

##### `name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

### `dsc_xscvmmoperationsmanagerserver`

The DSC xSCVMMOperationsManagerServer resource type.
Automatically generated from version 1.2.4.0

#### Properties

The following properties are available in the `dsc_xscvmmoperationsmanagerserver` type.

##### `dsc_enablemaintenancemodeintegration`

Data type: `Optional[Boolean]`

Indicates whether maintenance mode integration is enabled for this connection.

##### `dsc_enablepro`

Data type: `Optional[Boolean]`

Indicates whether PRO is enabled for this connection.

##### `dsc_opsmgrserver`

Data type: `String`

Specifies the fully qualified domain name (FQDN) of the System Center Operations Manager management server to which VMM connects.

##### `dsc_opsmgrservercredential`

Data type: `Optional[String]`

Specifies the name of the VMM RunAs account that VMM uses to connect to the Operations Manager management group.

##### `dsc_usevmmserverserviceaccount`

Data type: `Optional[Boolean]`

Specifies the service account that VMM uses to connect to Operations Manager.

#### Parameters

The following parameters are available in the `dsc_xscvmmoperationsmanagerserver` type.

##### `dsc_ensure`

namevar

Data type: `Enum['Present', 'Absent']`

An enumerated value that describes if the Operations Manager connection exists. Present {default}   Absent    

##### `dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### `dsc_scvmmadmincredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

Credential to be used to perform the operations.

##### `dsc_vmmservercredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

Specifies the credentials that Operations Manager uses to connect with VMM.

##### `name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

