require 'puppet/resource_api'

Puppet::ResourceApi.register_type(
  name: 'dsc_xscvmmadmin',
  dscmeta_resource_friendly_name: 'xSCVMMAdmin',
  dscmeta_resource_name: 'MSFT_xSCVMMAdmin',
  dscmeta_module_name: 'xSCVMM',
  dscmeta_module_version: '1.2.4.0',
  docs: 'The DSC xSCVMMAdmin resource type.
         Automatically generated from version 1.2.4.0',
  features: ['simple_get_filter', 'canonicalize'],
  attributes: {
    name: {
      type:      'String',
      desc:      'Description of the purpose for this resource declaration.',
      behaviour: :namevar,
    },
    dsc_scvmmadmincredential: {
      type: 'Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]',
      desc: 'Credential to be used to perform the operations.',
      behaviour: :parameter,
      mandatory_for_get: true,
      mandatory_for_set: true,
      mof_type: 'PSCredential',
      mof_is_embedded: true,
    },
    dsc_userrole: {
      type: 'String',
      desc: 'The Virtual Machine Manager user role.',
      behaviour: :namevar,
      mandatory_for_get: true,
      mandatory_for_set: true,
      mof_type: 'String',
      mof_is_embedded: false,
    },
    dsc_principal: {
      type: 'String',
      desc: 'The Virtual Machine Manager admin principal.',
      behaviour: :namevar,
      mandatory_for_get: true,
      mandatory_for_set: true,
      mof_type: 'String',
      mof_is_embedded: false,
    },
    dsc_psdscrunascredential: {
      type: 'Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]',
      desc: ' ',
      behaviour: :parameter,
      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'PSCredential',
      mof_is_embedded: true,
    },
    dsc_ensure: {
      type: "Optional[Enum['Present', 'Absent']]",
      desc: 'An enumerated value that describes if the principal is an Virtual Machine Manager admin. Present {default}   Absent    ',

      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'String',
      mof_is_embedded: false,
    },
  },
)
